#netzMadeDifficult


import numpy as n
import math as math
import random as random
import matplotlib.pyplot as plt


class Netz:
        
    def __init__(self, rad, num, xcor=0, ycor=0):
        
        self.xNetz = []
        self.yNetz = []
        self.Ursprung = [float(xcor), float(ycor)]
        self.Radius = rad
        self.short = rad

        for i in range (num):
            angle = math.pi / num * i * 2
            self.xNetz.append(xcor + (rad * math.cos(angle)))
            self.yNetz.append(ycor + (rad * math.sin(angle)))
            aengl = random.random() * 2 * math.pi
            raeng = random.random() * rad / num
            self.xNetz[i] += raeng * math.cos(aengl)
            self.yNetz[i] += raeng * math.sin(aengl)

    def getAngle(self, xcor, ycor):
        xkor = float(xcor) - self.Ursprung[0]
        ykor = float(ycor) - self.Ursprung[1]
        if(float(xcor) >= self.Ursprung[0]):
            return (math.acos(xkor / pow((xkor*xkor + ykor*ykor), 0.5)))
        else:   
            return (2*math.pi - math.acos(xkor / pow((xkor*xcor + ykor*ykor), 0.5)))

    #einfache Außenbegrenzung
    def makeOutside(self):
        xList = self.xNetz

        plt.plot([*self.xNetz, self.xNetz[0]], [*self.yNetz, self.yNetz[0]])

    #billo-Speichen
    def makeSpeichen(self):
        #Angle ist erstmal überflüssig
        Angle = [] 
        for i in range (len(self.xNetz)):
            Angle.append(self.getAngle(self.xNetz[i], self.yNetz[i]))
        
        for i in range (len(self.xNetz)):
            plt.plot([self.Ursprung[0], self.xNetz[i]], [self.Ursprung[1], self.yNetz[i]])
            if (self.short > pow(pow((self.Ursprung[0] - self.xNetz[i]), 2) + pow((self.Ursprung[1] - self.yNetz[i]),2),0.5)):
                self.short = pow(pow((self.Ursprung[0] - self.xNetz[i]), 2) + pow((self.Ursprung[1] - self.yNetz[i]),2),0.5)
    
    def makeSpiral(self):
        self.xSpiral = []
        self.ySpiral = []
        ragne = int((len(self.xNetz) * self.short) // 1)
        for i in range (ragne):
            k = i % len(self.xNetz)
            self.xSpiral.append(self.Ursprung[0] + (self.xNetz[k] * i / ragne))
            self.ySpiral.append(self.Ursprung[1] + (self.yNetz[k] * i / ragne))
        plt.plot(self.xSpiral, self.ySpiral)

newNet = Netz(20,15)

newNet.makeOutside()
newNet.makeSpeichen()
newNet.makeSpiral()

plt.show()